;**********************************************************************                                                            *
;    Filename:      PLL.asm            *
;    File Version:                                          *
; ;2020.03.01	Xɐ݌v@PLL/ QKP6T1i2018.05.06)  		                                 05                                 *
;    Author:   jk1xkp                                                     *
;    Company:                                                         *
;     
;	gp
;	ohb		PIC16F819 iȊOɂp\j
;
;		NbN	NbN 8MHz
;**********************************************************************
;    Notes: 
;1.LCD\ʒu AQM0802 8x2
; 0  7  .  0  5  0  .  0  
;@L  S  B  _  S  5  0  H  
;2.dSTEP SW(PORTB.6)ȂAdB
;  VXO[h(0-255)ݒ肪Ȃ
;6.TC9256Pgp  Xtal 8MHz  Ref=10kHziVXOŁ@Max7992.188/800=9.9902kHz),̐ݒB
;7.sATCFid̔z͏ȗj
;		( H:[qopen  L:[q0`2.4kGRDɗƂ)
;	ohbPUeWPX	
;	()̓sԍ
;	RA7-OSC1(16)		LCD AQM0802	;I2C LCD_SDA
;	RA6-OSC2(15)		LCD AQM0802	;I2C LCD_SCL
;	RA5-MCR(14)  H;AMin VCO<40MHz  L;FMin VCO>40MHz
;	RA4(03)			74HC595P_SCK	
;	RA2(01)			74HC595P_RCK 
;	RA2(01)			TC9256P_PRD
;	RA1(18)			TC9256P_CK	
;	RA0(17)      (Option MCP14010 dqVR@SCKj			
;		
;	RB7(13)			=TC9256P_DATA, 74HC595_Ser	    
;	RB6(12)			=STEP SW	
;	RB5(11)			ENC-A	
;	RB4(10)			 ENC-B
;	RB3(09)			 (mode CW,LSB,USB)	
;	RB2(08)			 (mode CW,LSB,USB)
;	RB1(07)			BAND 1 or BAND 2	
;	RB0(06)			Encoder 4x{iLj	
;	GND	

;**********************************************************************

	list      p=16f819           ; list directive to define processor
	#include <p16F819.inc>        ; processor specific variable definitions

	errorlevel  -302              ; suppress message 302 from list file

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON &_INTRC_IO  

; '__CONFIG' directive is used to embed configuration word within .asm file.
; The lables following the directive are located in the respective .inc file.
; See data sheet for additional information on configuration word settings.

	
#define		H59   	PORTA,4		;74HC595P_SCK
#define		H59_3  	PORTA,3		;3rd_74HC595P_SCK <Band select>
#define		RCK   	PORTA,2		;74HC595P_RCK
#define		PRD	   	PORTA,2		;TC9256P_PRD 

#define		T56   	PORTA,1		;TC9256P_CK
#define		P41   	PORTA,0		; MCP41010pSCK
#define		SDA   	PORTA,7		;I2C LCD_SDA
#define		SCL		PORTA,6		;I2C LCD_SCL

#define		DAT  	PORTB,7		;Data for TC9256 & 74HC595
#define		H59_2  	PORTB,2		;2nd_74HC595P_SCK <Band select>

;***** VARIABLE DEFINITIONS
VALUE		EQU	H'7A'
scn			EQU	H'7B'	;Bank0-4 
ADDR		EQU	H'7C'
pc_temp		EQU	H'7D'
w_temp		EQU 0x7E        ; variable used for context saving 
status_temp EQU 0x7F        ; variable used for context saving
;   --------------- adress 20&H  
USB0		EQU	0x20	;20hԒn! LCD2sڑ1"USB"\f[^[
USB1		EQU	0x21	;21hԒn! LCD2sڑ2"USB"\f[^[
USB2		EQU	0x22	;22hԒn! LCD2sڑ3"USB"\f[^[
plk			EQU	0x23	;23hԒnif PLL-Lock, then  plk=uLv=04ch, else uUv=055h
Encx4		EQU	0x24	;if Encx4,0=L, then Encoder non-click4{@ 	
s_vxo		EQU	0x25	;Adjust VXÓ@sub_vxo
;decrit1		EQU	0x26	;26hԒnBRIT̕΍(100HzP
;decrit2		EQU	0x27	;27hԒn sgp
VS			EQU	0x28	; S in case step Hz  /V in case AF Volume
Dstep0		EQU	0x29	; 50H or 10k	
Dstep1		EQU	0x2a	; 50H or 10k
Dstep2		EQU	0x2b	; 50H or 10k		;;	
stROM		EQU	0x2c	;must be 0x2c/ 
vxo			EQU	0x2d	;VXO(0-200) must be 0x2d-
nr0			EQU	0x2e	;PLL  must be 0x2e-
nr1			EQU	0x2f	;PLL  must be 0x2f-
;   -------------- adress 30&H
S_VXO		EQU	0x30	;g\␳vŹ@VXO@FS_VXO=@vxo@-		;		
dec0		EQU	0x31	; 10ii[ꏊiPOoCgj
dec1		EQU 0x32    	
dec2		EQU	0x33		
dec3		EQU	0x34		
dec4		EQU	0x35	;10MHz
dec5		EQU	0x36	;1MHz
dec6		EQU	0x37	;100kHz
dec7		EQU	0x38	;10kHz
dec8		EQU	0x39	;1kHz
dec9		EQU	0x3A	;;0.1kHz
Volum		EQU	0x3B	;;MCP41010 dqVR@Data;0<vol<255,, 
;ritSW		EQU	0x3C	;ritSW=1 or 0	
;N_rit		EQU	0x3D	;new RIT	
wait_cn		EQU	0x3E		;
wait_cn2	EQU	0x3F		
;    ------------- adress 40&H
val0		EQU	0x40		; ϊliRQrbgj
val1		EQU	0x41
val2		EQU	0x42
val3		EQU	0x43
val_m		EQU	0x44; ꎞ]i[ꏊiTu[`Ŏgpj
y0			EQU	0x45	
y1			EQU	0x46
y2			EQU	0x47
y3			EQU	0x48
step0		EQU	0x49	;;ENCD̎gstep=1(50Hz) or 200(10kHz)
N			EQU	0x4A		
het			EQU	0x4B	;/	up=1; lower=2
c_skip		EQU	0x4C	;sub-counter for Skip
ct			EQU	0x4D		;Sub counter
cp			EQU	0x4E	;wait_ routin ŎgĂJE^Bėpgp
cs			EQU	0x4F	;wait_ routin ŎgĂJE^Bėpgp
;    ------------- adress 50&H		
cn			EQU	0x50		;
cf			EQU	0x51		;
old23		EQU	0x52	;;mode(LSB, USB,CW) 
new23		EQU	0x53	; mode(LSB, USB,CW) 
poi			EQU	0x54
x0			EQU	0x55	;
x1			EQU	0x56
x2			EQU	0x57
x3			EQU	0x58
x_m			EQU	0x59	; ꎞ]i[ꏊ(Tu[`Ŏgpj  	
if0			EQU	0x5a	;IFg  IFset load
if1			EQU	0x5b
if2			EQU	0x5c
d4			EQU	H'5d'
d8			EQU	H'5e'
;reg01		EQU	H'5f'	;Encoder
;    ------------- adress 60&H	
NRb06		EQU	0x60	; ;RB߰Ă̌ݒl bit.6-0(@RB.4, 5)
ORb06		EQU	0x61	;ORB߰Ă̒l
old45		EQU	H'62'	; ;RB4,5߰Ẳߋl Encoder
new45		EQU	H'63'	; ;RB4,5߰Ă̌ݒl
old1		EQU	H'64'  	;;;RB1߰Ẳߋl
new1		EQU	H'65'	;;;RB1߰Ă̌ݒl
xor45bit	EQU	H'66'  	;;RB4,5߰Ẳߋl Encoder 2bit shift
cu			EQU	H'67'	;vxo=vxo+step  Up Carry Flag
cd			EQU	H'68'  	;vxo=vxo-step  Down Carry Flag
;old47		EQU	H'69'	;PORTB.2-7̕ω`FbN
;new47		EQU	H'6a'	;
nr2			EQU	H'6b'	;Ɂ@nr2=0
vfc			EQU	H'6c'	;intrruptuɂ@vfc.0=1
VCOport		EQU	H'6d'	;port=o5/xx/xx/xx/ o4/o3/o2/o1, 0=OFF, 1=Low(ON)
p_chk		EQU	H'6e'	;nr1 ω p_chk=1. if p_chk=1, then call PortChg
TCskp		EQU	H'6f'	;if TCskp=0, skip TC56set, else go 
;    ------------- adress 70&H	
VCO_n		EQU	H'70'	;;VCO name ?A/B/C/D
tempend		EQU	H'78' 	;temp Counter
;**********************************************************************
	ORG     0x000             ; processor reset vector


	goto    start              ; go to beginning of program

	ORG     0x004             ; interrupt vector location
isr		;;荞ݏ-routine
i_rb0	movwf	w_temp		;W@File w_tempւ̕ۑ
		swapf	STATUS,0
		clrf	STATUS		;Bank0
		movwf	status_temp	;status@File@̕ۑ
		bcf		INTCON,GIE
	;===============
isr1	movf	PORTB,0  ;	ȉ@g	
		andlw	B'00110000'	
		movwf	new45

		call	wt40u	;40 usec҂.ݺނ̓,ݸޖh~		
		movf	PORTB,0		
		andlw	B'00110000'	;masking othrt than RB4-5
		subwf	new45,0
		btfss	STATUS,Z
		goto	isr1

	;	btfsc	new45,0	;if new45.rb4=H, then goto pop2
	;	goto	pop2
	;	goto	encd
		movf	new45,0
		subwf	old45,0
		btfsc	STATUS,Z
		goto	pop1
		movf	new45,0
		xorwf	xor45bit,1

		movlw	H'53'	;if step=10kHz \/Chara "S" , always encoder=1
		subwf	VS,0
		btfsc	STATUS,Z
		goto	Enc_1

		btfsc	Encx4,0
		goto	Enc_1
		goto	Enc_4
		;--------------	ȉ@Encoder x1{ ̏	
Enc_1	movlw	B'11100000'		;old_BA=11, new_BA=10 then 1110+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'01000000'		;old_BA=01, new_BA=00 then 0100+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub
		goto	pop1
		;--------------	ȉ@Encoder x4{ ̏
Enc_4	btfss	step0,0	;if step=200(10kHz)=B'11001000', goto Enc_1
		goto	Enc_1

		movlw	B'11100000'		;old_BA=11, new_BA=10 then 1110+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'10000000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'00010000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'01110000'		
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	isadd

		movlw	B'11010000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'01000000'		;old_BA=01, new_BA=00 then 0100+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'00100000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub

		movlw	B'10110000'
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	issub
		goto	pop1
	;-------------------
issub	call	sub_v		;vxo=vxo-step0
		goto	pop
isadd	call 	add_v		;vxo=vxo+step0
		goto	pop

pop		bsf		vfc,0		;vfo change record, vfc=1
pop1	movf	PORTB,0	
		andlw	B'00110000'	
		movwf	old45
		movwf	xor45bit
		bcf		STATUS,C  ;Old45bit 2bit shift up
		rlf		xor45bit,1
		bcf		STATUS,C  ;
		rlf		xor45bit,1

pop2	swapf	status_temp,0	;status@File@̖߂
		movwf	STATUS	
		swapf	w_temp,1	;W@File@̖߂
		swapf	w_temp,0
		bcf		INTCON,0	;intcon-RBIF(tOj̃Zbg
		bsf		INTCON,GIE 		; Enable INTs.
				
		retfie
;-----------
; remaining code goes here
;--------------------------------------------------------------
tab_dp	addwf	PCL,1  	;f[^7bit=1ƂBAhXf[^͂̂܂
		retlw	H'20'		;poi=0	uU];20hԒnWX^
		retlw	H'21'		;poi=1	uSv
		retlw	H'22'		;poi=2	uBv	 
		retlw	H'a0'		;poi=3	u_v	
		retlw	H'28'		;poi=4	usv; S or V
		retlw	H'29'		;poi=5	u5v
		retlw	H'2a'		;poi=6	u0v 	 
		retlw	H'2b'		;poi=7	uHv;

;   	ȉ2s
		retlw	H'35'	;poi=8	dec[4]	;u1v 
		retlw	H'36'	;poi=9	dec[5]	;u4v 
		retlw	H'cd'	;poi=10	uMvG4dh+80h	 
		retlw	H'37'	;poi=11	dec[6]	;u0v
		retlw	H'38'	;poi=12	dec[7]	;u5v
		retlw	H'39'	;poi=13	dec[8]	;u0v		
		retlw	H'ac'	;poi=14	u,v 
		retlw	H'3a'	;poi=15	dec[9]	;u1v
		nop	

B_data	btfsc	new1,1
		goto	B_1
		goto	B_2

B_1 	;Nr=PLLP=(7030k+IF 11996.2k) /10k x (8000/7992.19)=1905
		;;Nr=1905̎̕\gvZ(100HzP)=(Nr-1) x100 x(1- 1/(2^10) )+(VXO/2) -IF;119962=70351 
		nop  	;Nband=1	;7MHz;PLO=19.026MHz
		movlw	H'71'	; 	;=PLLPNr=1905=H'0771'
		movwf	nr0		;
		movlw	H'07'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

B_2 	;Nr=PLLP=(10,100k+IF 11,996.2k) /10k x (8000/7992.19)=2211.7ˁ@2212
		;;Nr=2212̎̕\gvZ(100HzP)=(Nr-1) x100 x(1- 1/(2^10) )+(VXO/2) -IF;119962=100922 

		nop 	;Nband=2	;10MHz;PLO=22.096MHz
		movlw	H'A4'	; 	;=PLLPNr=2212=H'8A4'
		movwf	nr0		;
		movlw	H'08'	;
		movwf	nr1
		movlw	D'1'	;if D'1', then Up Hetro
		movwf	het
		return

	;==============
IFset	movf	new23,0
		movwf	old23
		btfss	new23,2 ;	;y@IF 100HzPʂŎgdata
		goto	IFcw
		btfss	new23,3	
		goto	IFusb
		goto	IFlsb

IFlsb	nop  		;;IF 100HzPʂŎgdata捞.
		movlw	H'9a'		;IFusb=11,996.2kHz=119962(100Hz)=H'01D49a'
		movwf	if0
		movlw	H'D4'
		movwf	if1
		movlw	H'01'
		movwf	if2 
		goto	Dmode
;		clrf	y3
		;return

IFusb	nop 		;;IF 100HzPʂŎgdata捞
		movlw	H'B8'		;IFlsb=11,999.2kHz=119992(100Hz)=H'01D4B8'
		movwf	if0
		movlw	H'D4'
		movwf	if1
		movlw	H'01'
		movwf	if2
		goto	Dmode 
		;clrf	y3
		;return

IFcw	nop		;;IF 100HzPʂŎgdata捞
		movlw	H'A2'		;IFcw=11,997.0kHz=119970(100Hz)=H'01D4A2'
		movwf	if0
		movlw	H'D4'
		movwf	if1
		movlw	H'01'
		movwf	if2
		goto	Dmode 
		;clrf	y3
		;return

Dmode 	btfss	new23,2
		goto	Dcw
		btfss	het,0		;;/	up=1; lower=2
		goto	Dh_2
		goto	Dh_1
		nop
Dh_1	btfss	new23,3	;Normal
		goto	Dusb
		goto	Dlsb

Dh_2	btfsc	new23,3	;Reveasal
		goto	Dusb
		goto	Dlsb

Dcw		movlw	H'20'	;Chara "_"
		movwf	USB0
		movlw	H'43'	;Chara "C"
		movwf	USB1
		movlw	H'57'	;Chara "W"
		movwf	USB2
		goto	D_end

Dlsb	movlw	H'4C'	;Chara "L"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

Dusb	movlw	H'55'	;Chara "U"
		movwf	USB0
		movlw	H'53'	;Chara "S"
		movwf	USB1
		movlw	H'42'	;Chara "B"
		movwf	USB2
		goto	D_end

D_end	return

VX_comp	addwf	PCL,1  	;S_VXO= vxo -@̎g\␳
		retlw	D'0'	;poi=0 0<vxo=<7
		retlw	D'1'	;poi=1 8<vxo=<15
		retlw	D'2'	;poi=2 16<vxo=<23
		retlw	D'3'	;poi=3 24<vxo=<31
		retlw	D'4'	;poi=4 32<vxo=<39
		retlw	D'5'	;poi=5 40<vxo=<47
		retlw	D'6'	;poi=6 48<vxo=<55
		retlw	D'7'	;poi=7 56<vxo=<63
		retlw	D'8'	;poi=8 64<vxo=<71
		retlw	D'9'	;poi=9 72<vxo=<79
		retlw	D'10'	;poi=10 80<vxo=<87
		retlw	D'11'	;poi=11 88<vxo=<95
		retlw	D'12'	;poi=12 96<vxo=<103
		retlw	D'11'	;poi=13 104<vxo=<111
		retlw	D'10'	;poi=14 112<vxo=<119
		retlw	D'9'	;poi=15 120<vxo=<127
		retlw	D'8'	;poi=16 128<vxo=<135
		retlw	D'7'	;poi=17 136<vxo=<143
		retlw	D'6'	;poi=18 144<vxo=<151
		retlw	D'5'	;poi=19 152<vxo=<159
		retlw	D'4'	;poi=20 160<vxo=<167
		retlw	D'3'	;poi=21 168<vxo=<175
		retlw	D'2'	;poi=22 176<vxo=<183
		retlw	D'1'	;poi=23 184<vxo=<191
		retlw	D'0'	;poi=24 192<vxo=<199
		retlw 	D'0'

;---------------------荞ݏuroutin------------
;-----------------------------------------------------------		
add_v					;15step		
		clrf	cu	;Up Carry Flag
		movlw	D'56'
		addwf	vxo,1	;vxo= vxo+ 56
		movf	step0,0
		addwf	vxo,1	;vxo=vxo+ step0
		btfss	STATUS,C
		bcf		cu,0
		btfsc	STATUS,C
		bsf		cu,0	;vxo=vxo+step  Up Carry Flag// C bitcu.0=1
		btfsc	cu,0
		bsf		TCskp,0	; Not skip TC56set
		
		bcf		STATUS,C
		movlw	D'1'
		btfsc	cu,0	;STATUS,C łCarry̑
		addwf	nr0,1	;nr0= nr0+1
		btfss	STATUS,C
		goto	add_1
		incf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1
	

add_1	movlw	D'56'
		btfsc	cu,0	;if cu.0=1, then Carry up,Zsv
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
sub_v				;14step
		clrf	cd	;Down Carry Flag
		movf	step0,0
		subwf	vxo,1	;vxo= vxo+ (256-step0)
		btfss	STATUS,C
		bcf		cd,0	;if cd,0=0, decf Nr
		btfsc	STATUS,C
		bsf		cd,0	;vxo=vxo-step  Down Carry Flag// C bitcd.0=0
		btfss	cd,0
		bsf		TCskp,0	; Not skip TC56set		

		movlw	D'1'
		btfss	cd,0	;;STATUS,C łCarry̑
		subwf	nr0,1	;nr0= nr0+ (256-1)
		btfsc	STATUS,C
		goto	sub_1
		decf	nr1,1
		bsf		p_chk,0	;if nr1 change, then p_chk,0=1

sub_1	movlw	D'56'
		btfsc	cd,0	;if cd.0=0, then Carry down
		movlw	D'0'						
		subwf	vxo,1	;W= vxo+ (256-56)
		;goto	pop
		return
;----------------
;----------------------------
Adjvxo	nop		;if STEP=L on powering, then Adjvxo
Adj1	call	readb		;input mode portb
Adj2	movf	PORTB,0	
		andlw	B'00110000'	
		movwf	new45
		
		call	wt5u	;5 usec҂.ݺނ̓,ݸޖh~
		movf	PORTB,0	
		andlw	B'00110000'	
		subwf	new45,0
		btfss	STATUS,Z
		goto	Adj2

Adj4	movf	new45,0		;if old45= new45, then goto Adj2
		subwf	old45,0
		btfsc	STATUS,Z
		goto	Adj2
		goto	Adj5

Adj5	btfss	old45,4		;if old45.4= HL,then next step, else goto Adj2(Adj_e)
		goto 	Adj_e
		btfsc	new45,4
		goto 	Adj_e
		goto	encd1

encd1	btfss	new45,5	;Rb5=LȂ vxo ZSub
		goto	Adj_dec	;Sub	VXO=VXO-1
		goto	Adj_add	;Add	VXO=VXO+

Adj_dec	decf	s_vxo,1		
		goto	Adj9

Adj_add	incf	s_vxo,1
		goto	Adj9

Adj8	bcf		INTCON,7	;荞݋֎~/come here from start
		clrf	s_vxo
Adj9	call	Adj595	;74HC595
		call	wt4ms
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h	
		movf	s_vxo,0	
		movwf	val0
		clrf	val1
		clrf	val2
		clrf	val3
		call	dcmain		;16i-10iϊ	/4900step
	;----	call	put chara
		;Cursol 1sTop
		movlw	H'80'		;Cursol 1sTop
		movwf	d4
		call	AQM08_cmd

		;-------;;\				
		clrf	c_skip		;if c_skip=0,AQM start from AQM08_Start,els from  		
		movf	dec7,0
		movwf	d4	
		call	AQM08_chara		;////////////

		movf	dec8,0
		movwf	d4		
		call	AQM08_chara	

		movlw	D'1'
		movwf	cn  	;cn=1 ;Stop for AQM08_chara
		movf	dec9,0
		movwf	d4		
		call	AQM08_chara			
	;----ȉ@LCD1sڕ\
		movf	s_vxo,0
		sublw	D'199'		;//W=199+ (256- S_vxo)G]
		movwf	vxo
		clrf	if0
		clrf	if1
		clrf	if2
		call	putfre
		call	put2nd	

Adj_e	movf	new45,0		;old45=new45
		movwf	old45
		goto	Adj1
;-------------------------------
Adj595	movf	s_vxo,0	;VXO Adjust
		movwf	d8
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn
		
		call	writb
		rrf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59		;SCK
		bsf		H59		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	HC595A
		bcf		RCK	
		bsf		RCK		;register to output latch
		return	

;------------------------------------------------------
start	bsf  	STATUS,RP0	;oN1		
		movlw	B'01110100'	;OSC=8MHz
		movwf	OSCCON
		bcf  	STATUS,RP0	;oN0

		movlw	D'255'
		movwf	wait_cn
		call	wait_ms

		bsf  	STATUS,RP0	;oN1
		movlw	B'00111111'	;RBvAbv;;INTEDG=FallEdge
		movwf	OPTION_REG	

		movlw	B'01001110'	;pinset(AN4=D,AN3=D,AN2=D,AN1=D,AN0=Analog, Vref+=5V, Vref-=GND) 
		movwf	ADCON1	;Left Justified 

		movlw	B'11100000'	;ra1,2,3,4,6,7  inputoutput
		movwf	TRISA
		bcf  	STATUS,RP0	;oN0
		clrf	PORTA

		bsf  	STATUS,RP0	;oN1
		movlw	B'01111111'	;rb.0-rb.6sin  !rb,#11111111b	
		movwf	TRISB		;trisb
		bcf  	STATUS,RP0	;oN0
		clrf	PORTB

	 	call 	AQM08_init	;I2C AQM0802 

st1		call	readb	;rb.2-7s input mode
		movf	PORTB,0
		andlw	B'00000010' ; Masking RBport other than RB.1
		movwf	new1
		movwf	old1
		call	Bnd_chg		;setting nr0, nr1
		
		call	writb
		call	TC56set			;TC9256P wakeupł
		call	TC56MD		;TC9256P wakeupł
		call	TC56set			;TC9256P {ł

		movf	PORTB,0
		andlw	B'00000001' ; Masking RBport other than RB.0
		movwf	Encx4		;if Encx4,0=L, then Encoder non-click4{@ 

		movlw	B'001100000'	;Encoder set
		movwf	old45	;
		movwf	new45	;

		movlw	D'128'
		movwf	Volum  	;;MCP41010 dqVR@Data;0<vol<255,

		movlw	D'199'
		movwf	vxo
		clrf	VCOport
		call	readb	;rb.2-7s input mode	;d Adjvxo
st2		btfsc	PORTB,6	;if STEP=L, then Adjvxo
		goto	st4
st3		goto	Adj8	;d VXO Adjvxo

st4		call	readb	;rb.2-7s input mode
		movf	PORTB,0
		andlw	B'00001100' ; Masking RBport other than RB.3-4
		movwf	old23
		movwf	new23
		call	IFset	

		movlw	B'11000000'
		movwf	ORb06
		movlw	B'11001110'
		movwf	NRb06

		movlw	D'1'
		movwf	het

		movlw	H'56'	; \/Chara "V" :Volum@̎@50Hz
		movwf	VS
		call	stp_chg		;step 200  1(50Hz)

	;	clrf	p_chk
	;	clrf	nr2
	

start0	movlw	H'55'	;PLL Lock=L, else U 
		movwf	plk

		movlw	B'00000000'
		movwf	VCOport		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
		
start35	clrf	TCskp
		bsf		TCskp,0	 	;Not skip TC56set
		call	writb
		call	RX	;nr1/nr0 setting
		
		call	TC56MD	;port PLL^Lock(OT4) set
		call	wt15ms
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put2nd
		call	put1st
		call	readb

start4	call	writb
		call	TC56MD	;port PLL^Un Lock(OT4) set

S_end	movlw	B'00001000'			;GIE=0 disable, INTE(RB4-7 Port Change)=1 enable
		movwf	INTCON	; 
 		bsf		INTCON,7	;荞݊Jn 

		clrf	vfc
		bsf		vfc,0

main	nop
main1	call	writb	;Rb.4-7 o̓|[g
		call	TC56MD	;port PLL^Un Lock(OT4) set
		call	RX			;TC9256P nr0, nr1 & HC595vxo
		call	TC56LK		;if PLL lock, plk=uLv=04ch, else plk=uUv=055h
	;	bcf		INTCON,7	;荞݋֎~ 
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
	;	bcf		INTCON,7	;荞݋֎~

main12	call	put2nd
main15	call	put1st
main2	;bcf		INTCON,7	;荞݋֎~ 
		bsf		INTCON,7	;荞݊Jn 
main4	bcf		vfc,0
	;----------------
main5	call	readb		;input mode portb
		bsf		INTCON,7	;荞݊Jn
main51	call	wt5u		;5 usec҂		
		btfsc	vfc,0	;
		goto	main	;
main53	call	chk23	;;RB2-3 ̓`FbN
		call	chk27		;RB0-7 ̓`FbN(RB4, 5)
				;Band, Mode, Step, Rit, ??
		bsf		INTCON,7	;荞݊Jn

		movf	PORTB,0		;Encoder@old45Axor45bit ̓ǂݍ 
		andlw	B'00110000'	
		movwf	old45	;
		bcf		INTCON,7	;荞݋֎~
		movwf	xor45bit
		bcf		STATUS,C  ;Old45bit 2bit shift up
		rlf		xor45bit,1
		bcf		STATUS,C  ;
		rlf		xor45bit,1
		bsf		INTCON,7	;荞݊Jn

main7	btfss	vfc,0	;
		goto	main51	;
		goto	main
;----------------------------
;-------------------------------
chk23	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'00001100'	;Rb2,3,̂ݎc
		movwf	new23	
		subwf	old23,0
		btfsc	STATUS,Z	;if new23=old23, then return
		return
		call	IFset	;LSB,USB,CW check
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put2nd
		call	put1st
		return

chk27	call	readb		;input mode portb	
		movf	PORTB,0		
		andlw	B'01001111'	;Rb0,1,2,3,,6,̂ݎc
chk50	movwf	NRb06
		andlw	B'00000010'	;Rb1 ̂ݎc
		movwf	new1

		movf	NRb06,0
		subwf	ORb06,0
		btfss	STATUS,Z		;if Nrb06=ORb06, then return
		goto	c27set	
		return
	
c27set	bcf		INTCON,7	;荞݋֎~
		movf	new1,0
		subwf	old1,0
		btfsc	STATUS,Z
		goto	c02
		call	Bnd_chg
		call	putfre		;LCD1s=vfo +/- (ifv+ifdef)@kHzvZ
		call	put2nd
		call	put1st

c02		movf	NRb06,0		;mov	old47,new47
		movwf	ORb06
	
ch5		btfss	NRb06,6		;if Rb.6=L, then Step_change
		goto	stp_chg

ch27e	movlw	D'100'
		movwf	wait_cn
		call	wait_ms
		return

;----------------------------------
RX		call	writb
		btfss	TCskp,0	;if TCskp=0, skip TC56set
		goto	RX1
		call	TC56set	;nr1/nr0 setting
RX1		call	RxHC595
		bcf		TCskp,0		;set Skippig TC56set
		return
;-------------------
;	RIT;A/DϊJn@@AN0|[g@AiO;;;́@Sub routeingpĂȂ	
adloop	movlw	B'01000001'	;set AD_channel=AN0, conversion_clock=16Tosc, )  
		movwf	ADCON0

		movlw	D'25'		;acquisition time wait 25usec
		movwf 	wait_cn	
		call	wait_us 

		bsf  	ADCON0,GO
ad_pol		
		nop  
		btfsc	ADCON0,GO
		goto	ad_pol		;AD conv polling
		movf	ADRESH,0
	;	movwf	N_rit		;ADϊLeft Justified@rit荞݁@(0-255)
		bcf  	ADCON0,0	;AD OFF
		bcf  	ADCON0,GO	;AD conv reset
		return
;--------------------------------
stp_chg		;    50Hz(step=1)	10kHz(step=200)  Vol(step=1)
		movf	VS,0
		sublw	H'53'	;; \/Chara "S"
		btfsc	STATUS,Z
		goto	Mvol		;Volume 
		goto	stp_1

stp_1	movf	VS,0
		sublw	H'73'	;; \/Chara "s"
		btfsc	STATUS,Z
		goto	st10k
		goto	st50

st50	movlw	D'1'
		movwf	step0

		movlw	H'73'	; \/Chara "s"
		movwf	VS
		movlw	H'35'	; steplƂ50H(35h, 30h, 48h)/Chara "5"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'48'	;Chara "H"
		movwf	Dstep2
		goto	stend

st10k	movlw	D'200'
		movwf	step0

		movlw	H'53'	; \/Chara "S"
		movwf	VS
		movlw	H'31'	; steplƂ10k(31h, 30h, 6Bh)/Chara "1"
		movwf	Dstep0
		movlw	H'30'	;Chara "0"
		movwf	Dstep1
		movlw	H'6B'	;Chara "k"
		movwf	Dstep2
		goto	stend
stend	call	put1st		;stepύX\
		goto	ch27e
	;	;return
	;------------------
Mvol	bcf		INTCON,7	;荞݋֎~/from here to //ȉ@Volum	
		movlw	H'56'	; \/Chara "V"
		movwf	VS
Mv1		call	wt4ms
		btfss	PORTB,6
		goto	Mv1
		goto	Mv5  	;ŏ̌vZ@& LCD\

Mv2		btfss	PORTB,6		;if step SW ON, return
		goto	EMv

		movf	PORTB,0  ;
		andlw	B'00110000'	
		movwf	new45

		movf	new45,0
		subwf	old45,0
		btfsc	STATUS,Z
		goto	Mv2

		movf	new45,0
		xorwf	xor45bit,1
		;--------------	ȉ@Encoder x1{ ̏	
Mv3		movlw	B'11100000'		;old_BA=11, new_BA=10 then 1110+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	Vadd

		movlw	B'01000000'		;old_BA=01, new_BA=00 then 0100+0000
		subwf	xor45bit,0
		btfsc	STATUS,Z
		goto	Vsub
		goto	Mv7					

Vadd	movlw	D'16'
		addwf	Volum,1		; Vadd
		goto	Mv5
Vsub	movlw	D'16'	
		subwf	Volum,1		; ;Vsub
		goto	Mv5

Mv5		movf	Volum,0
		movwf	val0
		bcf		STATUS,C
		rrf		val0,1		;val0= val0 /2
		bcf		STATUS,C
		rrf		val0,1		;val0= val0 /4
		bcf		STATUS,C
		rrf		val0,1		;val0= val0 /8
		bcf		STATUS,C
		rrf		val0,1		;val0= val0 /16
		call	dc_Vol
		call	MCP			;MCP41010 Loading
		call	put1st		;stepύX\

Mv7		movf	PORTB,0		;Old 45bit̍쐬
		andlw	B'00110000'	
		movwf	old45
		movwf	xor45bit
		bcf		STATUS,C  ;Old45bit 2bit shift up
		rlf		xor45bit,1
		bcf		STATUS,C  ;
		rlf		xor45bit,1
		goto	Mv2

EMv		call	wt4ms
	;	btfss	PORTB,6
	;	goto	EMv
		goto	st50

;----------------------------
Bnd_chg	movf	new1,0
		movwf	old1

setBand	call	B_data ;;setting nr0,nr1 & het
		movlw	D'199'	
		movwf	vxo		;2018.05.06
	;	bsf		p_chk,0	;if nr1 change, then p_chk,0=1
		return
;--------------------------------------------------------
TC56set	movf	nr0,0	;PLL @nr1, nr0
		movwf	x0
		movf	nr1,0
		movwf	x1
	
		movlw	H'D0'	;mov	d8,#0d0h		;gύX
		movwf	d8
		movlw	B'10011001'	;FML_in Pin11́@VCO>40MHz PORTA.5(MCR)=L
		btfsc	PORTA,5	;if MCR=H, then (1- 1/1024)
		movlw	B'10101001'	;AM_in Pin10́@VCO<40MHz, PORTA.5(MCR)=H	
		movwf	x2
		;mov	x[2],#10011001b		;OSC2/OSC1/Mode/FM/  R3/R2/R1/R0=10 01 1001b
		goto	TC56in			;  	OSC=7.2MHz, FML, fref=9kHz (ref=10kHz@8MHz)

TC56MD	movlw	H'D2'	;mov	d8,#0d2h		;VCOύXA 
		movwf	d8
		movlw	B'10100000'	
		movwf	x0		;mov	x[0],#10100000b	
						;reset/DOHZ/CLK/IF2/IF1/SC/G1/G0
						;1UL  /0   /1  /0  /0  /0 /0--0
		movlw	B'01001010'	
		movwf	x1		;mov	x[1],#01001010b		
						;o1 /M6 /M5 /x /x /XT /TEST/Start/xx	
						; /0  /1  /0 /0 /1  /0   /1    /0    /xx@	
						;Start=counter start bit, Reset=Unlock reset_bit
						;rrf1bitEւ;#1bit=start bit
		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		subwf	plk,0
		movlw	B'00000000'
		btfsc	STATUS,Z	;if plk=uLv=04ch,
		movlw	B'00001000'	;port o4="h" ;1

		xorwf	VCOport,0		;=o5/xx/xx/xx/ o4/o3/o2/o1, 0=High(OFF), 1=Low(ON)
		andlw	B'00001111'
		movwf	x2		;mov	x[2],OT		
						;o6/o5/xx/xx/xx/ o4/o3/o2/o1
						;x /x /x /x /x / 0 /0 /0 /0
						;rrf1bitEւ;0bito1(OT-1)́Ax[1].7ֈړ
		bcf		STATUS,C
		rrf		x2,1		;OT.0 x[1],7Ɉړ
		rrf		x1,1
TC56in	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		nop
		movlw	D'32'	;mov	cn,#32
		movwf	cn
		bcf		PRD
TC57in	rrf		x2,1
		rrf		x1,1
		rrf		x0,1
		rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD		;PERIOD=g
		decfsz	cn,1	;	djnz	cn,TC57in
		goto	TC57in

		bcf		PRD
		nop
		nop
		bsf		PRD
		return
;--------------------------------------------------------
TC56LK	movlw	H'D3'		;mov	d8,#0d3h		;PLL locko
		movwf	d8		
TC56out	call	writb
		bsf		PRD		;PERIOD=g
		bsf		T56		;Clock=H
		bsf		DAT		;Data=H
		movlw	D'8'	;mov	cn,#8
		movwf	cn
		bcf		PRD
TC58out	rrf		d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc 	STATUS,C
		bsf		DAT

		bcf		T56		;ǂݍ
		nop		;ێ1secȏ
		nop
		bsf		T56		;NbNŃf[^L
		nop		;ێ1secȏ
		nop
		bsf		PRD
		decfsz	cn,1	;djnz	cn,TC58out
		goto	TC58out

		bsf		STATUS,RP0	;oN1
		bsf		TRISB,7		; Rb7sIN
		bcf		STATUS,RP0	;oN0

		movlw	D'24'	;mov	cn,#24
		movwf	cn
TC60out	bcf		T56		;M󂯎ck
		nop		;Wait 1usec
		nop
		bsf		T56		;ckオŗL
		btfss	DAT
		bcf		STATUS,C	
		btfsc	DAT
		bsf		STATUS,C	
		
		rrf		y2,1		;Mf[^ y[2],7 ɓ
		rrf		y1,1
		rrf		y0,1
		decfsz	cn,1	;djnz	cn,TC60out
		goto	TC60out
		bcf		PRD
		nop	;ێ1secȏ
		nop
		bsf		PRD
		
;		btfss 	y0,0		;TC9256P UL bit EnableƂȂȂ
;		goto	TC56out		;̃[`甲oȂII
;		btfsc 	y[2],5
;		goto	TC56out

;TC61		movlw	00001111b
;		andwf	y[2],1 	

		bsf		STATUS,RP0	;oN1
		bcf		TRISB,7		; Rb6sout ??
		bcf		STATUS,RP0	;oN0

		movlw	H'4c'		;if PLL lock, then plk=uLv=04ch,
		btfsc	y0,1		;PLL lock1bit=0
		movlw	H'55'		;if PLL-UNLock, then  plk=uUv=055h
		movwf	plk
		return
;-------------------------------------
RxHC595	movf	vxo,0	;VXO tuning voltage
		sublw	D'199'		;//W=199+ (256-vxo)G]
		movwf	d8
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn
HC595A	call	writb
		rrf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bcf		H59		;SCK
		bsf		H59		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	HC595A
		bcf		RCK	
		bsf		RCK		;register to output latch
		return	
;-------------------------------------
MCP		call	writb
		bsf		RCK
		bcf		P41		;MCP41010 SCK
		movlw	B'00010011'
		movwf	d8
		bsf		P41		;MCP41010 SCK
		bcf		RCK		; TC74HC595 i/p
		movlw	D'8' 	;cn,#8
		movwf	cn

MCP2	bcf		P41		;MCP41010 SCK
		rlf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bsf		P41		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	MCP2

		movf	Volum,0	;dqVol Potentio tuning
		movwf	d8

		movlw	D'8' 	;cn,#8
		movwf	cn
MCP3	bcf		P41		;SCK	
		rlf  	d8,1
		btfss	STATUS,C
		bcf		DAT
		btfsc	STATUS,C
		bsf		DAT		

		bsf		P41		;SCK
		decfsz	cn,1		;djnz	cn,HC595A
		goto	MCP3

		bcf		P41		;SCK
		bsf		RCK		;register to output latch
		return	
;------------------------------		
putfre	; 5000step/ 170cycle+3600cycle= 3800cycle
;;Nr=1902̎̕\gvZ(100HzP)=(Nr-1) x(4+32+64) x(1- 1/(2^10) )+(VXO/2) -IF;119962=69952 
		;Upper Hetero  f(100HzP)=(Nr-1) x100+ vxo/2 -IF
		;Lower Hetero  f(100HzP)=(Nr-1) x100+ vxo/2 +IF
	;------;Nr x 100
		movf	nr0,0	;Nr x100= Nr x(4+32+64)
		movwf	val0
		movf	nr1,0
		movwf	val1
		clrf	val2

		movlw	1				;sub Nr= Nr-1
		subwf	val0,1
		movlw	1
		btfss	STATUS,C
		subwf	val1,1


		bcf		STATUS,C	;Nr=Nr x2
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x4
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;x(0-2) =val(0-2) 		;x=Nr x (4)
		movwf	x0
		movf	val1,0
		movwf	x1
		movf	val2,0
		movwf	x2

		bcf		STATUS,C	;Nr=Nr x8
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x16
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		bcf		STATUS,C	;Nr=Nr x32
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32)

		bcf		STATUS,C	;Nr=Nr x64
		rlf		val0,1	
		rlf		val1,1
		rlf		val2,1

		movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	add_xy	;(24bit)(24bit){y(24bit)@;x=Nr x (4+32+64)
	;------;Nr x 100  Ending
	;------------------------- Nr x100 x(1- 1/(2^10) )
		movf	x1,0		;val(0-2) = 1/(2^8) x val(0-2) 
		movwf	val0
		movf	x2,0
		movwf	val1
		clrf	val2

		bcf		STATUS,C	;val(0-2) = 1/(2^9) x val(0-2)
		rrf		val1,1
		rrf		val0,1	
		bcf		STATUS,C	;val(0-2) = 1/(2^10) x val(0-2) ;1/1024
		rrf		val1,1
		rrf		val0,1	
		btfsc	PORTA,5	;if MCR=H, then (1- 1/1024)
		goto	putf2

		bcf		STATUS,C	;val(0-2) = 1/(2^11) x val(0-2) ;1/2048
		rrf		val1,1
		rrf		val0,1	
		bcf		STATUS,C	;val(0-2) = 1/(2^12) x val(0-2) ;1/4096
		rrf		val1,1
		rrf		val0,1	

putf2	movf	val0,0		;y(0-2) =val(0-2) 
		movwf	y0
		movf	val1,0
		movwf	y1
		movf	val2,0
		movwf	y2
		call	sub_xy	;(24bit)(24bit)|y(24bit)//=Nr x100 x(1- 1/(2^10) )				
	;------------------------- Nr x100 x(1- 1/(2^10) ) Ending
		movlw	D'199'
		subwf	vxo,0	;W= vxo+ (256-199) 
		movlw	D'199'
		btfss	STATUS,C	;if Carry up,S_VXO=199	
		movf	vxo,0
		movwf	S_VXO
		bcf		STATUS,C	;S_VXO = 1/2 x S_VXO
		rrf		S_VXO,1
		bcf		STATUS,C	;S_VXO = 1/4 x S_VXO
		rrf		S_VXO,1
		bcf		STATUS,C	;S_VXO = 1/8 x S_VXO
		rrf		S_VXO,1
		movf	S_VXO,0
		andlw	B'00011111'	;S_VXO Max<25
		call	VX_comp	 	; vxo +@̎g\␳@̎A
		addwf	vxo,0		;W= vxo +
		movwf	y0
		bcf		STATUS,C
		rrf		y0,1	;y0=1/2 *vxo
		call	add_xy8	;(24bit)(24bit)+y(8bit)@//Nr x100 x(1- 1/(2^10)) + vxo/2
	;----------
		movf	if0,0		;y= IF setting 
		movwf	y0
		movf	if1,0
		movwf	y1
		movf	if2,0
		movwf	y2

		movlw	D'1'	;if D'1', then Up Hetro
		subwf	het,0
		btfsc	STATUS,Z
		goto	pf_U

pf_L	call	add_xy	;(24bit)(24bit){y(24bit) //x= x+IF
		goto	pf3

pf_U	call	sub_xy	;(24bit)(24bit)|y(24bit) //x= x-IF
		
pf3		movf	x0,0	
		movwf	val0
		movf	x1,0	
		movwf	val1
		movf	x2,0	
		movwf	val2
		clrf	val3		

		call	dcmain		;16i-10iϊ	/4900step
	;----------///Frequebcy Calc. Ending
		return
;--------------------
;		t[`

AQM08_init
		movlw	H'38'		;Function set
		movwf	d4
		call	AQM08_cmd
		call	wt40u		 	;wait 40sec
		movlw	H'39'		;Function set
		movwf	d4
		call	AQM08_cmd
		call	wt40u			;wait 40sec
		movlw	H'14'		;Internal OSC frequency
		movwf	d4
		call	AQM08_cmd
		call	wt40u			;wait 40sec
		movlw	H'73'		;Contrast set B'0111 0000' C3=1 73
		movwf	d4
		call	AQM08_cmd
		call	wt40u			;wait 40sec

		movlw	H'52'		;Power/Icon/Contrast control B'0101 0110'  notH'56'51
		movwf	d4
		call	AQM08_cmd
		call	wt40u			;wait 40sec
		movlw	H'6C'		;Follower control
		movwf	d4
		call	AQM08_cmd
		call	wait_255			;wait 255msec

		movlw	H'38'		;Function set
		movwf	d4
		call	AQM08_cmd
		call	wt40u		 	;wait 40sec
		movlw	H'0C'		;Display ON/OFF control
		movwf	d4
		call	AQM08_cmd
		call	wt40u		 	;wait 40sec
		movlw	H'01'		;Clear Display
		movwf	d4
		call	AQM08_cmd
		call	wt4ms		 	;wait 4msec
		movlw	H'06'		;Entory mode set
		movwf	d4
		call	AQM08_cmd
		call	wt40u		 	;wait 40sec
		return

	;-------
AQM08_cmd
		call	AQM08_Start
		call	AQM08_Adr	;slave address=B"01111100"
		call	AQM08_Ack
		movlw	B'00000000'		;Co=0,RS=0 command mode
		movwf	d8
		call	AQM08_data
		call	AQM08_Ack
		movf	d4,0		;d4=command instructiom
		movwf	d8
		call	AQM08_data
		call	AQM08_Ack
		call	AQM08_Stop
		call	wt40u			;wait 40sec
		return
		;----------
AQM08_chara
		movf	c_skip,1	;if c_skip=0, start from AQM08_Start
		btfss	STATUS,Z
		goto	cha_1
		incf	c_skip,1

		call	AQM08_Start
		call	AQM08_Adr	;slave address=B"01111100"
		call	AQM08_Ack
		movlw	B'01000000'		;Co=0,RS=1 character write mode
		movwf	d8
		call	AQM08_data
		call	AQM08_Ack
cha_1	movf	d4,0		;d4=charactor code
		movwf	d8
		call	AQM08_data
		call	AQM08_Ack

		movlw	D'1'
		subwf	cn,0	;W= cn-1 
		btfss	STATUS,Z	; if not cn=0, immediately return
		return
		call	AQM08_Stop
		call	wt40u			;wait 40sec
		return
		;----------
		;----------
AQM08_Start		;SDA=PORTA,7	SCL=PORTA,6	
		bsf		STATUS,RP0	;oN1
		bcf		TRISA,7		;PORTA.7 output=SDA
		bcf		TRISA,6		;PORTA.6 output =SCL
		bcf		STATUS,RP0	;oN0
		bcf		SDA
		nop		
        bsf		SCL   ;PORTA,6=SCL=H
		nop
		bsf		SDA	
		nop
		nop
	    bcf		SDA   ;PORTA,7=SDA=L
		nop
		bcf		SCL   ;PORTA,6=SCL=L
		return		 
		;--------
	
AQM08_Adr		;slave address=H"3E"(7bit) +"0"(R/W)=B"01111100"
		movlw	B'01111100'	;H'7C'
		movwf	d8
		call	AQM08_data
		return
		;----------

AQM08_Ack
		bsf		STATUS,RP0	;oN1
		bsf		TRISA,7		;PORTA.7 input=SDA
		bcf		STATUS,RP0	;oN0
		nop
M_A2	btfsc	SDA	
		goto	M_A2

M_LED	bsf		SCL		;SCL
		nop
		bcf		SCL		;SCL
		
		bsf		STATUS,RP0	;oN1
		bcf		TRISA,7		;PORTA.7 output=SDA
		bcf		STATUS,RP0	;oN0
		return
		;----------

AQM08_data
		bcf		SCL
		movlw	D'8'
		movwf	ct
M_d2	rlf  	d8,1
		btfss	STATUS,C
		bcf		SDA
		btfsc	STATUS,C
		bsf		SDA		
		nop
		bsf		SCL		;SCL
    	nop
		bcf		SCL		;SCL
		decfsz	ct,1		;djnz	ct,M_d2
		goto	M_d2
		return
	;-----------
AQM08_Stop
		bsf		STATUS,RP0	;oN1
		bsf		TRISA,6		;PORTA.6 input =SCL
		bcf		STATUS,RP0	;oN0  ;////SCL=H
		nop
		bsf		STATUS,RP0	;oN1
		bsf		TRISA,7		;PORTA.7 input=SDA
		bcf		STATUS,RP0	;oN0  ;/////SDA=H
		return	
		;-----------



;--------------------
put1st		; 590step+680us
		;Cursol 1sTop
		clrf	poi	;tab_dp(LCD)1Ԗڕ\

		movlw	H'80'		;Cursol 1sTop
		movwf	d4
		call	AQM08_cmd

		clrf	c_skip		;if c_skip=0,AQM start from AQM08_Start,els from  
		movlw	D'8'			;;8
		movwf	cn
		goto	dp_bun

put2nd		; 580step+680us
		;Cursol 2sTop
		movlw	D'8'	;tab_dp(LCD)8Ԗ=LCD2s1\
		movwf	poi

		movlw	H'c0'		;Cursol 2sTop
		movwf	d4
		call	AQM08_cmd

		clrf	c_skip
		movlw	D'8'			;	;8
		movwf	cn
		goto	dp_bun

;-------;\郋[`	;\X^ĆAtab_dpɑΉ	;poi=ʒuA0<=poi<tab_dpmaxl
dp_bun		;\				;/16x(35step+40us)=560step+640us
	;	bsf		RS
dpb1	movf	poi,0
		call	tab_dp
		movwf	d4
		btfsc	d4,7		;if d4.7=1, then dpb4
		goto	dpb4
		;goto	dpb3
dpb3	movwf	FSR		;WX^[AhX
		movf	INDF,0
		movwf	d4
		goto	dpb5			

dpb4	bcf		d4,7		;d4ɑΉ镶
dpb5	call	AQM08_chara		;
		incf	poi,1
		decfsz	cn,1
		goto	dpb1
		return
;--------------------------------------------------
readb	bsf		STATUS,RP0	;oN1	;rb.2-7s input mode
		movlw	B'11111111'	;rb.0-7sin  !rb,#11111111b
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		clrf	PORTB
		return

;---------
writb	bsf		STATUS,RP0	;oN1
		movlw	B'01111111'	; rb.7sout  	
		movwf	TRISB		;trisb
		bcf		STATUS,RP0	;oN0
		return
;----------------

;---------------------------------------------------------------------------------
;		I[_[̃EFCg
;
wait_255
		movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_ms

wt15ms	movlw	D'15'	;mov	wait_cn,#15
		movwf	wait_cn
		goto	wait_ms

wt4ms	movlw	D'4'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt1ms	movlw	D'1'	;mov	wait_cn,#4
		movwf	wait_cn
		goto	wait_ms

wt255u	movlw	D'255'	;mov	wait_cn,#255
		movwf	wait_cn
		goto	wait_us

wt40u	movlw	D'40'	;wait 40sec
		movwf	wait_cn
		goto	wait_us

wt5u	movlw	D'5'	;mov	wait_cn,#5
		movwf	wait_cn
		goto	wait_us

wait_20	movlw	D'20'		;mov	wait_cn,#20
		movwf	wait_cn
wait_ms  	
wait_ms0	
		movlw	D'0'	;mov	wait_cn2,#0
		movwf	wait_cn2
wait_ms1
		movlw	2	
		movwf	cp
wait_ms2
		nop
		decfsz	cp,1
		goto	wait_ms2		
		decfsz	wait_cn2,1
		goto	wait_ms1	;djnz	wait_cn2,wait_ms1

		decfsz	wait_cn,1
		goto	wait_ms0	;djnz	,
		return
;
;		ʂI[_[̃EFCg
;
wait_us		
wait_us0
		decfsz	wait_cn,1	;djnz	wait_cn,wait_us0
		goto	wait_us0
		return
;	---------------	end of lcd.asm

;---------------------
;	8rbgoCiPOiϊ
;	val08rbgf[^uB val0<256
dc_Vol	movlw	Dstep2		;; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devi			; ŉʕϊ
		call	devi			; ŉʕϊ 
		call	devi			;3JԂ
		return

devi	movlw	D'8'		;mov	cn,#8			; 8rbgԂ
		movwf	cn
		clrf	val_m
devi0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devi0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return

;---------------------------------------------------------------------
;	24rbgoCiPOiϊ
;
;	val24rbgf[^uBi:val[2]:val[1]:va[0])
;
;	dcmainR[B
;
;	decɓi[B
;		(dec[2]:dec[3]:...:dec[8]:dec[9])
;		dec[2]ŏʌdec[9]ŉʌłB
;
;	ϊval͔j󂳂B
;
;	sample:
;		val	= 00:00:04:D2 h
;		dec	= 00:00:00:00:00:00:01:02:03:04
;                  dec(0):dec(1):(2):(3):(4):(5):(6):(7):(8):dec(9)
;						(1,234)
;
dcmain
		movlw	dec9		;;mov	fsr,#dec_top	; i[ꏊl
		movwf	FSR
		incf	FSR,1
		call	devide			; ŉʕϊ 
		call	devide			;10JԂ
	;	call	devide
	;	call	devide
		call	devide

		call	devide
dcm1	call	devide
		call	devide
		call	devide
		call	devide			; ŏʕϊ
		
zeroblank
		movlw	D'5'		;**.*MHz\̑2܂blank\
		movwf	cn			;Zero Blanku

		movlw	dec2	;movlw  dec0	;; dec[0]i[ꏊl
		movwf	FSR
zb1		movlw	B'00110000'
		subwf	INDF,0
		btfss	STATUS,Z		;if dec[]=00, then continue, else return
		goto	zb3
zb2			;if dec[]=00, then dec[]=0ehł́Ablank \ƂȂ
		movlw	H'20'	;Letter'_'
		movwf	INDF	;movwf	indirect

		incf	FSR,1
		decfsz	cn,1
		goto	zb1

zb3		return

;
;		POTu[`
;		POŏZ܂
;
devide		
		movlw	D'24'		;	; 24rbgԂ
		movwf	cn
		clrf	val_m
devide0		
		bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
	;	rlf		val3,1
		rlf		val_m,1
		
		movlw	B'11110110'
		addwf	val_m,0
		btfsc	STATUS,C
		movwf	val_m		;mov	val_m,w
		btfsc	STATUS,C
		incf	val0,1
		
		decfsz	cn,1		;djnz	cn,devide0
		goto	devide0

		decf	FSR,1
		movf	val_m,0		;mov	indirect,val_m		; ]
		xorlw	B'00110000'	;;set upper bit=3 for LCD display
		movwf	INDF
		return
;----------------------------------------end of 10iϊ	
;	Z		(24bit)(24bit)|y(8bit)@
sub_xy8
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1
	;	btfss	STATUS,C
	;	subwf	x3,1
		return

;-----------------------
;	Z		(24bit)(24bit)|y(24bit)@;16 cycle
sub_xy
		movf	y0,0				;sub	x[0],y[0]
		subwf	x0,1
		movlw	1
		btfss	STATUS,C
		subwf	x1,1
		btfss	STATUS,C
		subwf	x2,1

		movf	y1,0				;sub	x[1],y[1];
		subwf	x1,1
		movlw	1
		btfss	STATUS,C
		subwf	x2,1

		movf	y2,0				;sub	x[2],y[2];
		subwf	x2,1		
		return
;--------------------------------------------------------------------
; 	Z	(24bit)(24bit){y(8bit)@
;
add_xy8				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
	;	btfsc	STATUS,C
	;	addwf	x3,1
		return
;------------------------------------
; 	Z	(24bit)(24bit){y(24bit)@
;
add_xy				
		movf	y0,0				;add	x[0],y[0]
		addwf	x0,1
		movlw	1
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		
		movf	y1,0				;add	x[1],y[1]
		addwf	x1,1
								
		movlw	1
		btfsc	STATUS,C
		addwf	x2,1

		movf	y2,0				;add	x[2],y[2]	]
		addwf	x2,1
		return
;-----------------------------------------------------------------------
;	|Z		x[32bit]=val[24bit] * N[8bit]
;
;	nr 24rbgf[^uB
;		i:val[2]:val[1]:val[0]) 	vZߒ val_m g
;       N 8ޯްuB
;                 N ;  ő  #255łB
;
;	xɓi[B
;                ix[3]:x[2]:x[1]:x[0]) 
;       		
;	ϊ N ͔j󂳂ȂB
;
;
mult_vN	clrf		x3
		clrf		x2
		clrf		x1
		clrf		x0
		clrf		val_m			;ǉ1
			
		movlw 	D'8'
		movwf 	cn
mult0		
		btfss	N,0
		goto	mutpas

		movf	val0,0				;add	x[0],step[0]
		addwf	x0,1
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x1,1
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val1,0				;add	x[1],step[1]
		addwf	x1,1		
									
		movlw	D'1'
		btfsc	STATUS,C
		addwf	x2,1
		btfsc	STATUS,C
		addwf	x3,1

		movf	val2,0				;add	x[2],step[2]	
		addwf	x2,1		
									
mutpas	bcf		STATUS,C
		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val_m,1		;ǉ1
		btfsc	STATUS,C
		bsf		val0,0

		bcf		STATUS,C
		rrf		N,1
		btfsc	STATUS,C
		bsf		N,7

		decfsz	cn,1			;	djnz	cn,mult0
		goto	mult0

		movlw	D'8'
		movwf	cn
multrot	bcf		STATUS,C
		rrf		val_m,1				;ǉ1
		rrf		val2,1
		rrf		val1,1
		rrf		val0,1
	;	btfsc	STATUS,C
	;	bsf		val3,7
		decfsz	cn,1			;djnz	cn,multrot
		goto 	multrot
		return
;---------------------------end of |Z
;-----------------------------------------------------
;	32rbgoCiZTu[`
;		val<32bit> = x<32bit> / y<16bit>; 
;
;	x 32 rbgf[^u܂B
;		ix[3]:x[2]:x[1]:x[0]) 
;       y 16ޯްu܂B
;              y[1]:y[0];  ő  H'FFFF'łB
;
;	val ɓi[܂B
;                ival[3]:val[2]:val[1]:val[0])  ]x[1][0]
;	vZ̉ߒ	Z		(32bit)(32bit)|y(32bit)gp
;       vZ̉ߒval[3]-val[0]Aval[0] ĝŒ`KvłB
;		
;
Div_xYY
		movf	y1,0		;y=y *256*256
		movwf	y3
		movf	y0,0
		movwf	y2
		clrf	y1
		clrf	y0
		movlw	D'17'			
		movwf	cn
		movlw	D'16'			
		movwf	cs
		clrf	val0
		clrf	val1
		clrf	val2
		clrf	val3

Dv1		movf	cs,1
		btfsc	STATUS,Z	;if y=0, can't divided then return
		return	
		btfsc	y3,7	;if y3.7 =0, then y rotate
		goto	Dv2
		bcf		STATUS,C
		rlf		y2,1
		rlf		y3,1
		incf	cn,1
		decfsz	cs,1
		goto 	Dv1		
				
Dv2		;;x>=y ? check
		movf	x3,0
		subwf	y3,0		; W=y3+ (256-x3)
		btfss	STATUS,C	; if y3<x3, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y3>x3, then Dv4
		goto	Dv4

		movf	x2,0
		subwf	y2,0		; W=y2+ (256-x2)
		btfss	STATUS,C	; if y2<x2, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y2>x2, then Dv4
		goto	Dv4

		movf	x1,0
		subwf	y1,0		; W=y1+ (256-x1)
		btfss	STATUS,C	; if y1<x1, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y1>x1, then Dv4
		goto	Dv4

		movf	x0,0
		subwf	y0,0		; W=y0+ (256-x0)
		btfss	STATUS,C	; if y0<x0, then Dv3
		goto	Dv3
		btfss	STATUS,Z	; if y0>x0, then Dv4
		goto	Dv4
		goto	Dv3

Dv3		;x>=y@Ȃ̂ňZ
		call 	sub_xy	;(32bit)(32bit)|y(32bit)
		bsf		STATUS,C	
		goto	Dv5

Dv4		;x<y Ȃ̂ 
		bcf		STATUS,C	
Dv5		rlf		val0,1
		rlf		val1,1
		rlf		val2,1
		rlf		val3,1	
		decfsz	cn,1		
		goto	Dv6
		return
Dv6		bcf		STATUS,C
		rrf		y3,1	
		rrf		y2,1
		rrf		y1,1	
		rrf		y0,1
		goto	Dv2
	;=============================
      END                       ; directive 'end of program'
